      PROGRAM ALPHER
C
C     Herwig/Alpgen main program for HzTool/JetWeb.
C     N.B. Use only for unweighted running!
C

c      IMPLICIT NONE
c     HERWIG common blocks etc., includes "IMPLICIT NONE" 
c     so need to come first. ???
#include "hzhrwsteer.inc"
#include "alpsho.inc"

c     HBOOK stuff
      INTEGER NWPAWC,H
      PARAMETER (NWPAWC=9000000)
      COMMON/PAWC/H(NWPAWC)

      EXTERNAL HWUDAT

c     Counter used in event loop
      INTEGER COUNTER

      INTEGER IPVETO

c     Total cross section
      REAL XSECLOC

c     Mean charged multiplicity
      DOUBLE PRECISION nchavg

c     Temporary variables for output of HZNEVT
      INTEGER HZNEV2
      REAL HZLUMI2

c     HERWIG process type
      INTEGER IPROCLOC

c     Event type: 1 = pbar-p, 2 = ep, 3 = ee
c      INTEGER ITYPLOC

c     HERWIG particle ID number and name
      INTEGER iwig
      CHARACTER*8 nwig

c     Author groups for PDF sets. Should move somewhere more sensible. ???
      CHARACTER*8 NPDFAUT(7)
      CHARACTER*8 PPDFAUT(9)

c     PDF IDs for beam particles, and function to return these
      INTEGER HZPDFSEL

      LOGICAL abort

c     JM: buffer for hwigin output

      character*80 hwibuf(11)
      character*5 versn

      common /hwvrsn/ versn

      integer lenocc

c     Author groups for PDF sets. Should move somewhere more sensible. ???
c     Proton authors
      DATA NPDFAUT /'DO','DFLM','MRS','CTEQ','GRV','ABFOW','BM'/
c     Photon authors
      DATA PPDFAUT /'NN','NN','LAC','NN','GRVph','NN','NN','WHIT-G'
     $     ,'SaSph'/

c     HEPEVT prime common block - included in HERWIG include file
c#include "hepevtp.inc"

c     Misleadingly named common block
c     Contains information on generator, no. of events etc.
#include "heracmn.inc"

c     Common block with steering parameters
#include "hzcontrol.inc"
#include "hzhrwcontrol.inc"
#include "hzalpcontrol.inc"

c     Function to calculate mean multiplicity for HERWIG
c     Move to common block, e.g. HZFUNC?
      DOUBLE PRECISION HZHWAVRG

      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
      PRINT*,'* jetweb_alpher.fpp'/
     $     /'$Date: 2007-01-14 22:26:56 +0000 (Sun, 14 Jan 2007) $'  
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''

      GEN = 'HRW'

c     Read steering cards etc.
      CALL HZCARDS(1)
      CALL HZHRWCARDS
      CALL HZALPCARDS
      CALL HZCARDS(2)

      IPROC = -100
 
c     JM: redirect unit 6 to a buffer so we can extract the version of herwig
c         from the message that hwigin prints and write it in the xml
            
            open(6, file="hwigin.tmp")

      CALL HWIGIN

c     JM: now redirect unit 6 back to stdout
c         assumes stdout is where it should be!
            
      close(6)
      open(6, file="/dev/stdout")
      
      open(66, file="hwigin.tmp", status='old')

c     fortran I/O is a nightmare!

      read(66, '(a)')hwibuf
      
c     write(*,*)'writing hwibuf'
      write(*,*)hwibuf

c     write(*,*)lenocc(hwibuf)
      
      rewind(66)
      
      read(66, *)hwibuf
      
      close(66)
      
      versn = hwibuf(2)
      
c     close(6)
      
      CALL JIMMIN

c     Set PTJIM
      PTJIM=HZPTJIM

c     Choose JIMMY running mode
      JMUEO=HZJMUEO

      AUTPDF(1) = 'HWLHAPDF'
      MODPDF(1) = HZPDFSEL(2)
      AUTPDF(2) = 'HWLHAPDF'
      MODPDF(2) = HZPDFSEL(1)


c     Reduced printout from LHAPDF.
      CALL SetLHAPARM('LOWKEY')

ccc  Set HERWIG-specific parameters from steering

c  Proton and photon radius
      IF (HZPRRAD.GT.-999.) THEN
         JMRAD(73)=DBLE(HZPRRAD) 
         JMRAD(75)=DBLE(HZPRRAD) 
         JMRAD(91)=DBLE(HZPRRAD) 
         JMRAD(93)=DBLE(HZPRRAD) 
      ENDIF
      IF (HZPHRAD.GT.-999.) THEN
         JMRAD(59) =DBLE(HZPHRAD) 
         JMRAD(121)=DBLE(HZPHRAD) 
         JMRAD(127)=DBLE(HZPHRAD) 
      ENDIF
            
      IF (HZQSPAC.GT.-999.)  QSPAC=DBLE(HZQSPAC) 
      IF (HZCLMAX.GT.-999) CLMAX = HZCLMAX
      IF (HZCLPOW.GT.-999) CLPOW = HZCLPOW
      IF (HZPSPLT1.GT.-999) PSPLT(1) = HZPSPLT1
      IF (HZPSPLT2.GT.-999) PSPLT(2) = HZPSPLT2
      IF (HZPHAD.GT.-999) PHAD = HZPHAD
      IF (HZPRSOF.GT.-999) PRSOF = HZPRSOF
      IF (HZBTCLM.GT.-999) BTCLM = HZBTCLM
      IF (HZQCDLAM.GT.-999.) QCDLAM=DBLE(HZQCDLAM) 
      IF (HZVQCUT.GT.-999) VQCUT = DBLE(HZVQCUT)
      IF (HZVGCUT.GT.-999) VGCUT = DBLE(HZVGCUT)
      IF (HZVPCUT.GT.-999) VPCUT = DBLE(HZVPCUT)
      IF (HZPTRMS.GT.-999.)  PTRMS=DBLE(HZPTRMS) 
      
      IF (HZIOPREM.GT.-999) IOPREM = HZIOPREM
      IF (HZOMEGA0.GT.-999) OMEGA0 = DBLE(HZOMEGA0)
      IF (HZASFIXD.GT.-999) ASFIXD = DBLE(HZASFIXD)
      IF (HZQ2WWMX.GT.-999) Q2WWMX = DBLE(HZQ2WWMX)
      
      IF (HZPDFPOW.GT.-999) PDFPOW = DBLE(HZPDFPOW)
      IF (HZPDFX0.GT.-999) PDFX0 = DBLE(HZPDFX0)
      
      IF (HZISPAC.GT.-999)   ISPAC=HZISPAC 
      IF (HZIFLMAX.GT.-999)  IFLMAX=HZIFLMAX
      IF (HZNFLAV.GT.-999)   NFLAV=HZNFLAV


ccc  JIMMY multiple interaction flag 
      MSFLAG = HZJIMMY

c     Set initial seed for random number generator
c      NRN(1)=hzrnd1
c      NRN(2)=hzrnd2
c      WRITE(*,*) 'Using random number sequence ',NRN(1),', ',NRN(2
c     $           )

ccc Set Alpgen parameters Note: In alpgen (alpsho.f) these are not given
c     sensible defaults. In fact there are READ(*,*) lines to read them
c     in. It is recommended that you modify you r installation of
c     alpsho.f if all you want to do is set these to the recommended
c     values.  If you want to run in batch mode (without reading from
c     stdin) you'll have to do something like this anyway.
      IF (HZIEXC.NE.-999) IEXC=HZIEXC
      IF (HZRCLUS.GT.-999.) RCLUS=HZRCLUS
      IF (HZRCLUS.GT.-999.) ETACLMAX=HZETACLMAX
      IF (HZRCLUS.GT.-999.) ETCLUS=HZETCLUS
      FILENAME=HZALFILE(1:LENOCC(HZALFILE))//' '
      write(*,*) "IEXC = ",IEXC
      WRITE(*,*) "Filename is:"//FILENAME
      COUNTER=0

c     Compute parameter-dependent constants
      CALL HWUINC
            
c     Switch off decays of final-state particles selected to be stable
C      DO 23 iloop = 1, 200
C         IF (HZSTAB(iloop).ne.-9999) THEN
C            WRITE(*,*) 'Making particle stable: ',HZSTAB(iloop)
c     Convert PDG code to HERWIG particle name and set to be stable
C            CALL HWUIDT(1,HZSTAB(iloop),IWIG,NWIG)
C            CALL HWUSTA(NWIG)
C         ENDIF
C 23   CONTINUE
            
c     Initialize elementary processes
      CALL HWEINI
      IF (MSFLAG.EQ.1) CALL JMINIT
      
            
c     Initialize HBOOK histogramming
      CALL HZHISTO(1,nchavg)
                                    
c     Generate events
      write (6,*) 'Starting main event generation loop'
      MAXPR = 2

      write(*,*) 'Number of events to generate is ', MAXEV

 50   CONTINUE

      COUNTER = COUNTER+1
      IF (1000*(COUNTER/1000).EQ.COUNTER) THEN
         WRITE(*,*) 'Attempts:',COUNTER
      ENDIF

c     Initialize event
      CALL HWUINE
c     Generate hard subprocess
      CALL HWEPRO

c matching-driven veto
      CALL UPVETO(IPVETO)
      IF(IPVETO.NE.0) THEN
        CALL HWWARN('UPVETO',-1)
        GOTO 100
      ENDIF


c     Generate parton cascades
      CALL HWBGEN
      
c     Generate multiparton interactions
      IF (MSFLAG.EQ.1) THEN
         CALL HWMSCT(abort)
      ENDIF
               
      CALL HWDHOB

C---  DO CLUSTER HADRONIZATION
      CALL HWCFOR
C---  DO CLUSTER DECAY
      CALL HWCDEC
C---  DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---  DO HEAVY FLAVOUR DECAYS
      CALL HWDHVY
C---  ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---  FINALISE EVENT
 100  CONTINUE
      CALL HWUFNE

      IF (IPVETO.EQ.0) THEN
c     Transfer information to HEPEVT common, HERACMN etc.
         CALL HZFILHEP
      
c     Set event weight WTX as some analysis routines seem to use this
c     Only dealing with unweighted events at the moment
         WTX = 1.0
               
c     Fill histograms
         CALL HZHISTO(2,nchavg)

      ENDIF

          
      GOTO 50

c--   end of run. Stopped from the user process event reader at the end
c--   of the file.
      
      END

c     End of run processing
      SUBROUTINE HWAEND

#include "hzhrwsteer.inc"
c     Contains information on generator, no. of events etc.
#include "heracmn.inc"
c     Common block with steering parameters
#include "hzcontrol.inc"
#include "hzhrwcontrol.inc"

c     NB this is a dummy. No info passed!!
      DOUBLE PRECISION nchavg

      IF (MSFLAG.EQ.1) CALL JMEFIN
            
c     Set number of events and cross section (in nb) in HERACMN
      NTOT = NEVHEP
      XSEC = AVWGT
            
c     Finish off HBOOK stuff
      CALL HZHISTO(3,nchavg)

c     Start XML file
      IF (hzxmlout.ne.0) THEN
         CALL HZHRWXML(0)
         CALL HZHRWXML(1)
         CALL HZHRWXML(2)
         CALL HZHRWXML(3)
      ENDIF

c     Write XML run information for each process
      IF (hzxmlout.ne.0) THEN
         CALL HZHRWXML(4)
      ENDIF
            
c     Write histograms in aida format
      IF (hzaidaout.NE.0) THEN
         CALL HZAIDA
      ENDIF

c     Output histograms and close file.
      CALL HZHISTO(-1,nchavg)

      IF (hzxmlout.NE.0) THEN
c     Finish and close XML file
         CALL HZHRWXML(-3)
         CALL HZHRWXML(-1)
      ENDIF

      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
      PRINT*,'* Outputted and ended'    
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''

      RETURN
      END
 
