      PROGRAM ALPPYT
C
C     Pythia main program for HzTool/JetWeb.
C
C     N.B. Use only for unweighted running!
C
      IMPLICIT NONE

#include "alpsho.inc"

c     HBOOK stuff
      INTEGER NWPAWC,H
      PARAMETER (NWPAWC=9000000)
      COMMON/PAWC/H(NWPAWC)

      EXTERNAL PYDATA

c     Counter used in event loop
      INTEGER IEV, ILOOP

c     Total cross section [pb]
      REAL XSECPB

c     Mean charged multiplicity
      DOUBLE PRECISION nchavg

c     Beam particles
      CHARACTER*8 part1, part2

c     Event type: 1 = pbar-p, 2 = ep, 3 = ee
c      INTEGER ITYPLOC

c     Process loop
      INTEGER JPROC

C...USER PROCESS EVENT COMMON BLOCK.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &    ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &    VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE/HEPEUP/

      EXTERNAL UPINIT, UPVETO, UPEVNT

c     HEPEVT prime common block
#include "hepevtp.inc"

c     Misleadingly named common block
c     Contains information on generator, no. of events etc.
#include "heracmn.inc"

c     Pythia common blocks
#include "hzpytsteer.inc"

c     Common block with steering parameters
#include "hzcontrol.inc"
#include "hzpytcontrol.inc"
#include "hzalpcontrol.inc"

c     Move to common block, e.g. HZFUNC?
      DOUBLE PRECISION HZPYAVRG

      integer lenocc


      PRINT*,''
      PRINT*,'*******************************************************'
      PRINT*,'*'
c <<<<<<< .mine
      PRINT*,'* jetweb_pyt.fpp $Date: 2006-02-07 17:50:15 +0000 
     & (Tue, 07 Feb 2006) $'  
c =======
      PRINT*,'* jetweb_pyt.fpp'/
     $     /'$Date: 2006-11-10 17:04:06 +0000 (Fri, 10 Nov 2006) $'  
c >>>>>>> .r133
      PRINT*,'*'
      PRINT*,'*******************************************************'
      PRINT*,''

      GEN = 'PYT'

c     Read steering cards etc.
      CALL HZCARDS(1)
      CALL HZPYTCARDS
      CALL HZALPCARDS
      CALL HZCARDS(2)

c     Create local copy of beam particle types (and convert to upper case using KERNLIB util)
c     Don't really need to convert to upper case but makes reusing HERWIG code easier
      PART1 = hzb1
      PART2 = hzb2
      CALL CLTOU(PART1)
      CALL CLTOU(PART2)

c     Set beam momenta: 1st beam has positive pz
      P(1,1)=0.
      P(1,2)=0.
      P(1,3)=hzpb1
      P(2,1)=0.
      P(2,2)=0.
      P(2,3)=-hzpb2

c     Begin loop over the MSTP14 options.
      DO jproc=1,hzmaxmstp14

c     Copy MSTP, PARP, MSTJ, PARJ and CKIN from steering cards
c     Must overwrite MSTP(14) with the value from hzmstp14 (if present)
         DO 22 iloop = 1, 200
            IF (HZPARP(ILOOP).GT.-9999.) PARP(ILOOP) = HZPARP(ILOOP)
            IF (HZMSTP(ILOOP).GT.-9999) MSTP(ILOOP) = HZMSTP(ILOOP)
            IF (HZPARJ(ILOOP).GT.-9999.) PARJ(ILOOP) = HZPARJ(ILOOP)
            IF (HZMSTJ(ILOOP).GT.-9999) MSTJ(ILOOP) = HZMSTJ(ILOOP)
            IF (HZCKIN(ILOOP).GT.-9999.) CKIN(ILOOP) = HZCKIN(ILOOP)
 22      CONTINUE

c     Copy KFIN

         do 111 iloop = 1, 81
            if(hzkfn2(iloop).gt.-9999) kfin(2, iloop-41) = hzkfn2(iloop)
 111     continue

C     Copy MDME1 from steering cards
       DO 211 iloop = 1, 4285
         IF (HZMDME1(ILOOP).GT.-9999) MDME(ILOOP,1) = HZMDME1(ILOOP)
  211   CONTINUE
                  
c     Set PDFs of beam particles using LHAPDF, overriding MSTP
         IF (hzpdfpr.GT.-9999) THEN
            MSTP(51) = hzpdfpr
            MSTP(52) = 2
         ENDIF
         IF (hzpdfph.GT.-9999) THEN
            MSTP(55) = hzpdfph
            MSTP(56) = 2
         ENDIF

c     Reduced printout from LHAPDF.
         CALL SetLHAPARM('LOWKEY')

         call pygive('MSTP(143)=1') ! CALL UPVETO, ALLOW JET-PARTON MATCHING

         
c     Set initial seed for random number generator
         mrpy(1)=hzrnd1
         WRITE(*,*) 'Using random number sequence ',mrpy(1)
         

ccc Set Alpgen parameters Note: In alpgen (alpsho.f) these are not given
c     sensible defaults. In fact there are READ(*,*) lines to read them
c     in. It is recommended that you modify you r installation of
c     alpsho.f if all you want to do is set these to the recommended
c     values.  If you want to run in batch mode (without reading from
c     stdin) you'll have to do something like this anyway.
      IF (HZIEXC.NE.-999) IEXC=HZIEXC
      IF (HZRCLUS.GT.-999.) RCLUS=HZRCLUS
      IF (HZRCLUS.GT.-999.) ETACLMAX=HZETACLMAX
      IF (HZRCLUS.GT.-999.) ETCLUS=HZETCLUS
      FILENAME=HZALFILE(1:LENOCC(HZALFILE))//' '
      write(*,*) "IEXC = ",IEXC
      WRITE(*,*) "Filename is:"//FILENAME


c     Re-initialize Pythia to clear lumi and number of events etc.
c         CALL PYINIT('3MOM',part1,part2,0.D0)
         CALL PYINIT('USER',' ',' ',0D0)

c     Switch off decays of final-state particles selected to be stable
         DO 24 iloop = 1, 200
            IF (HZSTAB(iloop).ne.-9999) THEN
               WRITE(*,*) 'Making particle stable: ',HZSTAB(iloop)
               MDCY(PYCOMP(HZSTAB(iloop)),1) = 0
            ENDIF
 24      CONTINUE


c     Write our some numbers to the log file:-
c     User-Defined Limits on Kinematical Variables
         CALL PYSTAT(4)
c     Summary of Status Codes and Parameter Values (common /PYPARS/)
         CALL PYSTAT(5)
c     List parameter value table (common /PYDAT1/, /PYDAT2/)
         CALL PYLIST(13)

c     Initialize HBOOK histogramming
         CALL HZHISTO(1,nchavg)

c     Generate events
         write (6,*) 'Starting main event generation loop'

         IEV=0
 1       IEV=IEV+1

c     Call Pythia to generate event
         CALL PYEVNT
c     Transfer information to HEPEVT common, HERACMN etc.
         CALL HZFILHEP
c     Write out first couple of events
         IF (IEV.LE.2) CALL PYLIST(1)
c     Set event weight WTX as some analysis routines seem to use this
c     Only dealing with unweighted events at the moment
         WTX = 1.0
c     Fill histograms
         CALL HZHISTO(2,nchavg)
         IF (MOD(IEV,1000).EQ.0) write(*,*) 'PYTHIA EVENT:',IEV
         
         IF(HZNEV.NE.0.AND.IEV.EQ.HZNEV) GOTO 140
C     NUP=0: REACHED END OF UNWEIGHTED EVENT FILE
         IF(NUP.EQ.0) GOTO 140

 130     GOTO 1

c     End of event loop.
 140     CONTINUE

c     Print out some info from Pythia
         CALL PYSTAT(1)   
         
c     Fill number of events and cross section [nb] in HERACMN
         ntot=real(hznev)
         xsec=oldxsec(0,3)*1E+06
         write(*,*) 'jetweb_pyt: ntot, xsec [nb] = ',ntot,xsec
         
c     Finish off HBOOK stuff
         CALL HZHISTO(3,nchavg)

c     Start XML file (only for the first process)
         IF (hzxmlout.ne.0.AND.jproc.EQ.1) THEN
               CALL HZPYTXML(0)
               CALL HZPYTXML(1)
               CALL HZPYTXML(2)
               CALL HZPYTXML(3)
         ENDIF

c     Write XML run information for each process
         IF (hzxmlout.ne.0) THEN
               CALL HZPYTXML(4)
         ENDIF

 999     CONTINUE
      ENDDO

c     Write histograms in aida format
      IF (hzaidaout.NE.0) THEN
         CALL HZAIDA
      ENDIF

c     Output histograms and close file.
      CALL HZHISTO(-1,nchavg)

C     Close SLHA files
      IF(IMSS(21).NE.0) CLOSE(IMSS(21))
      IF(IMSS(22).NE.0) CLOSE(IMSS(22))
      
      IF (hzxmlout.ne.0) THEN
c     Finish and close XML file
       CALL HZPYTXML(-3)                
       CALL HZPYTXML(-1)
      ENDIF
      
      PRINT*,''
      PRINT*
     $     ,'*******************************************************'
      PRINT*,'*'
      PRINT*,'* Outputted and ended'    
      PRINT*,'*'
      PRINT*
     $     ,'*******************************************************'
      PRINT*,''

      END
