      SUBROUTINE HZHISTO(iflag,avrg)
c
c  Do all the HBOOK stuff for JetWeb/HzTool main programs.
c    iflag = 1: 
c      initialize HBOOK
c      open RZ file
c    iflag = 2:
c      call analysis (histogramming) routines
c    iflag = 3:
c      termination for analysis routines.
c    iflag = -1 
c      output histograms and close file.
c
c     An offset of [JPROC]*1000 is added.
c
c     avrg is the mean charged multiplicity, which is required by
c     some analysis routines and should be calculated before calling
c     this subroutine for the first time.
c

      IMPLICIT NONE

c     Argument to subroutine
      INTEGER iflag, iflag1, jproc

c     HBOOK stuff
      INTEGER NWPAWC,H
      PARAMETER (NWPAWC=9000000)
      COMMON/PAWC/H(NWPAWC)
      INTEGER istat, icycle

c     Function to find number of occupied characters in a string (KERNLIB)
      INTEGER lenocc

c     File stem for output files
      CHARACTER*80 stem

c     Mean charged multiplicity
      DOUBLE PRECISION avrg

cc      write (6,*) 'HZHISTO called with iflag = ',iflag

      iflag1 = mod(iflag,1000)
      jproc  = iflag/1000

      IF (iflag1.eq.1.and.jproc.le.1) THEN
c       File stem is first command-line argument
        CALL GETARG(1,stem)
c       Reserve space for histograms
        CALL HLIMIT(nwpawc)
c       Open file for output histograms
        CALL HROPEN(45,'HISTO',
     &       stem(1:LENOCC(stem))//'.rz','N',1024,istat)
      ENDIF

      IF (iflag1.ne.-1) THEN
         CALL HZROUTINES(iflag,avrg)
      ELSE
         CALL HCDIR('//PAWC',' ')
         CALL HCDIR('//HISTO',' ')
         CALL HROUT(0,icycle,'T')
         CALL HREND('HISTO')
      ENDIF

      RETURN
      END
