      SUBROUTINE HZROUTINES(iflag,avrg)
c
c     Call the analysis routines with the appropriate flag
c
c     avrg is the mean charged multiplicity, which is required by
c     some analysis routines and should be calculated before calling
c     this subroutine for the first time.
c
c     HZTOOL conventions telling you what these routine names mean can 
c     be found at http://hztool.hep.ucl.ac.uk

      IMPLICIT NONE

#include "hzcontrol.inc"

      INTEGER iflag
      DOUBLE PRECISION avrg

cc      write (6,*) 'HZROUTINES called with iflag = ',iflag

c     template routine
         IF (hztest) CALL hztemplate(iflag)
c     HERA
         IF (hzroutine(1)) CALL hz94176(iflag)
         IF (hzroutine(2)) CALL hz95033(iflag)
         IF (hzroutine(27)) CALL hz95219(iflag)
         IF (hzroutine(28)) CALL hz96094(iflag)
         IF (hzroutine(29)) CALL hz97164(iflag)
         IF (hzroutine(30)) CALL hz97191(iflag)
         IF (hzroutine(31)) CALL hz97196(iflag)
         IF (hzroutine(32)) CALL hz98018(iflag)
         IF (hzroutine(33)) CALL hz98085(iflag)
         IF (hzroutine(34)) CALL hz98162(iflag)
         IF (hzroutine(35)) CALL hz99057(iflag)
         IF (hzroutine(36)) CALL hz00035(iflag)
         IF (hzroutine(40)) CALL hz01220(iflag)
c removed from calling sequence. was crashing.
c this is preliminary data anyway, so should not really be here.
c         IF (hzroutine(41)) CALL hzi02849(iflag)
         IF (hzroutine(42)) CALL hz01225(iflag)
         IF (hzroutine(57)) CALL hz00166(iflag)
         IF (hzroutine(60)) CALL hz02228(iflag)
         IF (hzroutine(72)) CALL hz94033(iflag)
         IF (hzroutine(73)) CALL hz95007(iflag)
         IF (hzroutine(75)) CALL hz95036(iflag) 
         IF (hzroutine(76)) CALL hzh9505001(iflag)
         IF (hzroutine(77)) CALL hz95072(iflag)
         IF (hzroutine(78)) CALL hz95084(iflag)
         IF (hzroutine(79)) CALL hz95108(iflag)
         IF (hzroutine(80)) CALL hz95115(iflag)
         IF (hzroutine(81)) CALL hz95221(iflag) 
         IF (hzroutine(82)) CALL hz96039(iflag)
         IF (hzroutine(83)) CALL hz96076(iflag)
         IF (hzroutine(84)) CALL hz96122(iflag)
         IF (hzroutine(85)) CALL hz96138(iflag)
         IF (hzroutine(86)) CALL hz96160(iflag)
         IF (hzroutine(87)) CALL hz96215(iflag)
         IF (hzroutine(88)) CALL hz97098(iflag)
         IF (hzroutine(89)) CALL hz97108(iflag)
         IF (hzroutine(90)) CALL hz97158(iflag)
         IF (hzroutine(91)) CALL hz97179(iflag)
         IF (hzroutine(92)) CALL hz97183(iflag)
         IF (hzroutine(93)) CALL hz97210(iflag)
         IF (hzroutine(94)) CALL hz98029(iflag)
         IF (hzroutine(95)) CALL hz98038(iflag)
         IF (hzroutine(96)) CALL hz98044(iflag)
         IF (hzroutine(97)) CALL hz98050(iflag)
         IF (hzroutine(98)) CALL hz98076(iflag) 
         IF (hzroutine(99)) CALL hz98087(iflag)
         IF (hzroutine(100)) CALL hz98092(iflag)
         IF (hzroutine(101)) CALL hz98121(iflag)
         IF (hzroutine(102)) CALL hz98143(iflag)
         IF (hzroutine(103)) CALL hz98169(iflag)
         IF (hzroutine(104)) CALL hz98204(iflag) 
         IF (hzroutine(105)) CALL hz98205(iflag) 
         IF (hzroutine(106)) CALL hz98210(iflag)
         IF (hzroutine(107)) CALL hz99091(iflag)
         IF (hzroutine(108)) CALL hz99094(iflag)
         IF (hzroutine(109)) CALL hz99101(iflag)
         IF (hzroutine(110)) CALL hz99126(iflag)
         IF (hzroutine(111)) CALL hz99193(iflag)
         IF (hzroutine(112)) CALL hz00017(iflag)
         IF (hzroutine(113)) CALL hz00040(iflag)
         IF (hzroutine(114)) CALL hz00174(iflag)
         IF (hzroutine(115)) CALL hz00181(iflag)
         IF (hzroutine(116)) CALL hz01064(iflag)
         IF (hzroutine(117)) CALL hz01100(iflag)
         IF (hzroutine(118)) CALL hz02079(iflag)
         IF (hzroutine(119)) CALL hz03015(iflag)
         IF (hzroutine(120)) CALL hz03094(iflag)
C  won't link, contacting author...
C         IF (hzroutine(121)) CALL hz03160(iflag)
         IF (hzroutine(123)) CALL hzh9810020(iflag)
         IF (hzroutine(124)) CALL hzh0302034(iflag)
         IF (hzroutine(126)) CALL hzh0006017(iflag)
         IF (hzroutine(129)) CALL hzh0312057(iflag)
c     virtual photon routine
         IF (hzroutine(130)) CALL hzh0404033(iflag)
c     virtual photon charm routine
         IF (hzroutine(131)) CALL hzh0307071(iflag)

c     these routines sometimes run with colour singlet added.
         IF (hzroutine(26)) CALL hz95194(iflag)
         IF (hzroutine(58)) CALL hz02023(iflag)


c     LEP
      IF (hzroutine(37)) CALL hzc96132(iflag)
      IF (hzroutine(38)) CALL hzc98113(iflag)
      IF (hzroutine(59)) CALL hzh0301013(iflag)
C   won't link, contacting author

c      IF (hzroutine(125)) CALL hzc98091(iflag)
      IF (hzroutine(127)) CALL hzc00109(iflag)


c     Tevatron
      IF (hzroutine(39)) CALL hzf01211e(iflag)
      IF (hzroutine(51)) CALL hzh9807014(iflag)
      IF (hzroutine(52)) CALL hzh9912022(iflag)
      IF (hzroutine(53)) CALL hzh9807018(iflag)
      IF (hzroutine(62)) CALL hzf89201e(iflag,avrg)
      IF (hzroutine(63)) CALL hzplb435453(iflag,avrg)
      IF (hzroutine(65)) CALL hzh9905024(iflag)
      IF (hzroutine(67)) CALL hzh0001021(iflag)
      IF (hzroutine(68)) CALL hz0307080(iflag)
      IF (hzroutine(69)) CALL hzh0412071(iflag) 
      IF (hzroutine(70)) CALL hzh0010026(iflag)
      IF (hzroutine(71)) CALL hzh9907009(iflag)
      IF (hzroutine(132)) CALL hzh0404004(iflag)
c      if(hzroutine(132)) call hzf01345e(iflag)

c     SPS
      IF (hzroutine(54)) CALL hzc88172a(iflag,avrg)
      IF (hzroutine(55)) CALL hzprt154247(iflag,avrg)
      IF (hzroutine(56)) CALL hzc88172b(iflag,avrg)

      IF (hzroutine(128)) CALL hzc87112(iflag)
      RETURN
      END
