      SUBROUTINE HZXMLIM(iunit,name,nil,nih,idim,njl,njh,jdim,iarr)
c
c     Write XML intMatrix element.
c
c     iunit = LUN for output
c     name  = "name" attribute of intMatrix element
c     nil     = lower index (i dimension)
c     nih     = upper index (i dimension)
c     idim    = length of the i dimension
c     njl     = lower index (j dimension)
c     njh     = upper index (j dimension)
c     jdim    = length of the j dimension
c     iarr    = 2D array, iarr(i,j), dimensioned as idim x jdim
c     EG
c     Consider the 2D array declared as INTEGER matrix(0:100,0:100)
c     nil=0, nih=100, idim=101, njl=0, njh=100, jdim=101.

      IMPLICIT NONE

      INTEGER iunit
      CHARACTER*(*) name
      INTEGER nil,nih,idim,njl,njh,jdim
      INTEGER iarr(nil:nih,njl:njh)

      INTEGER I,J

c     Buffer for formatting numbers in output
      CHARACTER*14 buff1
      CHARACTER*6 buff2,buff3
      INTEGER buflen1,buflen2
      PARAMETER (buflen1=14,buflen2=6)

c     Complete element to write out
      CHARACTER*100 elem
      
c     Function to find number of occupied characters in a string (KERNLIB)
      INTEGER lenocc

      write (buff2,'(I6)') idim
      call cleft(buff2,1,buflen2)
      write (buff3,'(I6)') jdim
      call cleft(buff3,1,buflen2)
      elem = '<hep:intMatrix name="'//name//'" ilength="'//
     &     buff2(1:lenocc(buff2))//'" jlength="'//
     &     buff3(1:lenocc(buff3))//'">'
      write (iunit,'(A)') elem(1:lenocc(elem))

      DO I = nil, nih
        DO J = njl, njh
          write (buff2,'(I6)') I
          write (buff3,'(I6)') J
          write (buff1,'(I14)') iarr(I,J)

          call cleft(buff2,1,buflen2)
          call cleft(buff3,1,buflen2)
          call cleft(buff1,1,buflen1)

          elem = '<hep:matrixElement iindex="'//
     &         buff2(1:lenocc(buff2))//'" jindex="'//
     &         buff3(1:lenocc(buff3))//'">'//
     &         buff1(1:lenocc(buff1))//'</hep:matrixElement>'

          write (iunit,'(A)') elem(1:lenocc(elem))
        ENDDO
      ENDDO

      write (iunit,'(A)') '</hep:intMatrix>'

      RETURN
      END
